package com.greenorange.promotion.model.dto.user;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;

/**
 * 用户表添加请求体
 */
@Data
@Schema(description = "用户表添加请求体", requiredProperties =
        {"userAccount", "userPassword", "miniOpenId", "userName", "userAvatar", "points", "userRole"})
public class UserAddRequest implements Serializable {

    /**
     * 账号
     */
    @Schema(description = "账号", example = "qingcheng")
    private String userAccount;

    /**
     * 密码
     */
    @Schema(description = "密码", example = "123456")
    private String userPassword;

    /**
     * 小程序openId
     */
    @Schema(description = "小程序openId", example = "324324")
    private String miniOpenId;

    /**
     * 用户昵称
     */
    @Schema(description = "用户昵称", example = "Jack")
    private String userName;

    /**
     * 用户头像
     */
    @Schema(description = "用户头像", example = "https://www.com")
    private String userAvatar;

    /**
     * 积分
     */
    @Schema(description = "积分", example = "1200")
    private Integer points;

    /**
     * 用户角色
     */
    @Schema(description = "用户角色", example = "user")
    private String userRole;


    @Serial
    private static final long serialVersionUID = 1L;
}
