package com.greenorange.promotion.model.dto.user;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import java.io.Serial;
import java.io.Serializable;
import com.greenorange.promotion.common.PageRequest;

/**
 * 用户表查询请求体，继承自分页请求 PageRequest
 */
@Data
@Schema(description = "用户表查询请求体", requiredProperties = {"current", "pageSize"})
public class UserQueryRequest extends PageRequest implements Serializable {

    /**
     * 用户id
     */
    @Schema(description = "用户id", example = "1")
    private Long id;

    /**
     * 用户昵称
     */
    @Schema(description = "用户昵称", example = "Jack")
    private String userName;


    /**
     * 用户角色
     */
    @Schema(description = "用户角色", example = "user")
    private String userRole;


    @Serial
    private static final long serialVersionUID = 1L;
}
