package com.greenorange.promotion.model.vo.user;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;

/**
 * 用户表 视图对象
 */
@Data
@Schema(description = "用户表 视图对象")
public class UserVO implements Serializable {

    /**
     * 用户id
     */
    @Schema(description = "用户id", example = "1")
    private Long id;

    /**
     * 账号
     */
    @Schema(description = "账号", example = "${field.example}")
    private String userAccount;

    /**
     * 密码
     */
    @Schema(description = "密码", example = "${field.example}")
    private String userPassword;

    /**
     * 小程序openId
     */
    @Schema(description = "小程序openId", example = "${field.example}")
    private String miniOpenId;

    /**
     * 用户昵称
     */
    @Schema(description = "用户昵称", example = "${field.example}")
    private String userName;

    /**
     * 用户头像
     */
    @Schema(description = "用户头像", example = "${field.example}")
    private String userAvatar;

    /**
     * 积分
     */
    @Schema(description = "积分", example = "${field.example}")
    private Integer points;

    /**
     * 用户角色
     */
    @Schema(description = "用户角色", example = "${field.example}")
    private String userRole;


    @Serial
    private static final long serialVersionUID = 1L;
}
